<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Content-Type");

require_once '../dbconnection.php';

if ($_SERVER["REQUEST_METHOD"] == "POST") {
    $userid = $_POST['userid'] ?? null;
    $postid = $_POST['postid'] ?? null;

    if (!$userid || !$postid) {
        echo json_encode(["success" => false, "message" => "User ID and Post ID are required"]);
        exit;
    }

    // Check if a like record exists for this user and post
    $checkSql = "SELECT status FROM postlikes WHERE userid = '$userid' AND postid = '$postid'";
    $result = $conn->query($checkSql);

    if ($result->num_rows > 0) {
        // Record exists, update status
        $row = $result->fetch_assoc();
        $newStatus = ($row['status'] === 'liked') ? 'unliked' : 'liked';

        $updateSql = "UPDATE postlikes SET status = '$newStatus' WHERE userid = '$userid' AND postid = '$postid'";
        if ($conn->query($updateSql) === TRUE) {
            echo json_encode(["success" => true, "message" => "You have $newStatus  the post"]);
        } else {
            echo json_encode(["success" => false, "message" => "Error updating status: " . $conn->error]);
        }
    } else {
        // No record exists, insert new row with status 'liked'
        $insertSql = "INSERT INTO postlikes (userid, postid, status) VALUES ('$userid', '$postid', 'liked')";
        if ($conn->query($insertSql) === TRUE) {
            echo json_encode(["success" => true, "message" => "You liked this Post"]);
        } else {
            echo json_encode(["success" => false, "message" => "Error inserting like: " . $conn->error]);
        }
    }

    $conn->close();
} else {
    echo json_encode(["success" => false, "message" => "Invalid request"]);
}
?>
